

<!DOCTYPE html>

<html lang="ja">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.25.8. grn_ctx &#8212; Groonga v10.1.1-31-g1e46ba6ドキュメント</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    <script src="../../_static/translations.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="索引" href="../../genindex.html" />
    <link rel="search" title="検索" href="../../search.html" />
    <link rel="next" title="7.25.9. grn_db" href="grn_db.html" />
    <link rel="prev" title="7.25.7. grn_content_type" href="grn_content_type.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">オープンソースのカラムストア機能付き全文検索エンジン</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../en/html/reference/api/grn_ctx.html">English</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             accesskey="I">索引</a></li>
        <li class="right" >
          <a href="grn_db.html" title="7.25.9. grn_db"
             accesskey="N">次へ</a> |</li>
        <li class="right" >
          <a href="grn_content_type.html" title="7.25.7. grn_content_type"
             accesskey="P">前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../api.html" accesskey="U"><span class="section-number">7.25. </span>API</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.25.8. </span><code class="docutils literal notranslate"><span class="pre">grn_ctx</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="grn-ctx">
<h1><span class="section-number">7.25.8. </span><code class="docutils literal notranslate"><span class="pre">grn_ctx</span></code><a class="headerlink" href="#grn-ctx" title="このヘッドラインへのパーマリンク">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.25.8.1. </span>概要<a class="headerlink" href="#summary" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><a class="reference internal" href="#c.grn_ctx" title="grn_ctx"><code class="xref c c-type docutils literal notranslate"><span class="pre">grn_ctx</span></code></a> は最も重要なオブジェクトです。<a class="reference internal" href="#c.grn_ctx" title="grn_ctx"><code class="xref c c-type docutils literal notranslate"><span class="pre">grn_ctx</span></code></a> はその時点の情報を保持します:</p>
<ul class="simple">
<li><p>最後に発生したエラー。</p></li>
<li><p>その時点のエンコーディング。</p></li>
<li><p>デフォルトの閾値。（例: <a class="reference internal" href="../commands/select.html#select-match-escalation-threshold"><span class="std std-ref">match_escalation_threshold</span></a>）</p></li>
<li><p>デフォルトのコマンドバージョン。（ <a class="reference internal" href="../command/command_version.html"><span class="doc">コマンドバージョン</span></a> ）を参照のこと。</p></li>
</ul>
<p><a class="reference internal" href="#c.grn_ctx" title="grn_ctx"><code class="xref c c-type docutils literal notranslate"><span class="pre">grn_ctx</span></code></a> は基盤となる機能を提供します:</p>
<ul class="simple">
<li><p>メモリ管理機能</p></li>
<li><p>ロギング機能</p></li>
</ul>
<p>ほとんどのAPIは <a class="reference internal" href="#c.grn_ctx" title="grn_ctx"><code class="xref c c-type docutils literal notranslate"><span class="pre">grn_ctx</span></code></a> を最初の引数にとります。</p>
<p>同じ <a class="reference internal" href="#c.grn_ctx" title="grn_ctx"><code class="xref c c-type docutils literal notranslate"><span class="pre">grn_ctx</span></code></a> を二つ以上のスレッドからは扱えません。<a class="reference internal" href="#c.grn_ctx" title="grn_ctx"><code class="xref c c-type docutils literal notranslate"><span class="pre">grn_ctx</span></code></a> はスレッドごとに作成する必要があります。一つのスレッドでは <a class="reference internal" href="#c.grn_ctx" title="grn_ctx"><code class="xref c c-type docutils literal notranslate"><span class="pre">grn_ctx</span></code></a> を二つ以上扱えますが、通常はその必要はありません。</p>
</div>
<div class="section" id="example">
<h2><span class="section-number">7.25.8.2. </span>例<a class="headerlink" href="#example" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>TODO...</p>
</div>
<div class="section" id="reference">
<h2><span class="section-number">7.25.8.3. </span>リファレンス<a class="headerlink" href="#reference" title="このヘッドラインへのパーマリンク">¶</a></h2>
<dl class="c type">
<dt id="c.grn_ctx">
<em class="property">type </em><code class="sig-name descname">grn_ctx</code><a class="headerlink" href="#c.grn_ctx" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>TODO...</p>
</dd></dl>

<dl class="c function">
<dt id="c.grn_ctx_init">
grn_rc <code class="sig-name descname">grn_ctx_init</code><span class="sig-paren">(</span><a class="reference internal" href="#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, int <em>flags</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_ctx_init" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>ctxを初期化します。</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> -- 初期化するctx構造体へのポインタを指定します。</p></li>
<li><p><strong>flags</strong> -- 初期化する <code class="docutils literal notranslate"><span class="pre">ctx</span></code> のオプションを指定します。</p></li>
</ul>
</dd>
<dt class="field-even">戻り値</dt>
<dd class="field-even"><p>成功時は <code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> 、エラー時は <code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> 以外。</p>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_ctx_fin">
grn_rc <code class="sig-name descname">grn_ctx_fin</code><span class="sig-paren">(</span><a class="reference internal" href="#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_ctx_fin" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>ctxの管理するメモリを解放し、使用を終了します。</p>
<p><a class="reference internal" href="#c.grn_ctx_init" title="grn_ctx_init"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_ctx_init()</span></code></a> ではなく <a class="reference internal" href="#c.grn_ctx_open" title="grn_ctx_open"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_ctx_open()</span></code></a> で <code class="docutils literal notranslate"><span class="pre">ctx</span></code> を初期化した場合、 <a class="reference internal" href="#c.grn_ctx_fin" title="grn_ctx_fin"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_ctx_fin()</span></code></a> ではなく <a class="reference internal" href="#c.grn_ctx_close" title="grn_ctx_close"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_ctx_close()</span></code></a> を使わなければいけません。</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> -- 解放するctx構造体へのポインタを指定します。</p></li>
</ul>
</dd>
<dt class="field-even">戻り値</dt>
<dd class="field-even"><p>成功時は <code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> 、エラー時は <code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> 以外。</p>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_ctx_open">
<a class="reference internal" href="#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<code class="sig-name descname">grn_ctx_open</code><span class="sig-paren">(</span>int <em>flags</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_ctx_open" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>初期化された <a class="reference internal" href="#c.grn_ctx" title="grn_ctx"><code class="xref c c-type docutils literal notranslate"><span class="pre">grn_ctx</span></code></a> オブジェクトを返します。</p>
<p><a class="reference internal" href="#c.grn_ctx_init" title="grn_ctx_init"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_ctx_init()</span></code></a> で初期化された <a class="reference internal" href="#c.grn_ctx" title="grn_ctx"><code class="xref c c-type docutils literal notranslate"><span class="pre">grn_ctx</span></code></a> オブジェクトは構造体の実体をAPIの呼び元で確保するのに対して、 <a class="reference internal" href="#c.grn_ctx_open" title="grn_ctx_open"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_ctx_open()</span></code></a> ではGroongaライブラリの内部で、実体を確保します。
どちらで初期化された <a class="reference internal" href="#c.grn_ctx" title="grn_ctx"><code class="xref c c-type docutils literal notranslate"><span class="pre">grn_ctx</span></code></a> も、 <a class="reference internal" href="#c.grn_ctx_fin" title="grn_ctx_fin"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_ctx_fin()</span></code></a> で解放できます。
<a class="reference internal" href="#c.grn_ctx_open" title="grn_ctx_open"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_ctx_open()</span></code></a> で確保した <a class="reference internal" href="#c.grn_ctx" title="grn_ctx"><code class="xref c c-type docutils literal notranslate"><span class="pre">grn_ctx</span></code></a> 構造体に関しては、<a class="reference internal" href="#c.grn_ctx_fin" title="grn_ctx_fin"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_ctx_fin()</span></code></a> で解放した後に、その <a class="reference internal" href="#c.grn_ctx" title="grn_ctx"><code class="xref c c-type docutils literal notranslate"><span class="pre">grn_ctx</span></code></a> で作成した <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj"><code class="xref c c-type docutils literal notranslate"><span class="pre">grn_obj</span></code></a> を <a class="reference internal" href="grn_obj.html#c.grn_obj_close" title="grn_obj_close"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_obj_close()</span></code></a> によって解放しても問題ありません。</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>flags</strong> -- 初期化する <code class="docutils literal notranslate"><span class="pre">ctx</span></code> のオプションを指定します。</p></li>
</ul>
</dd>
<dt class="field-even">戻り値</dt>
<dd class="field-even"><p>初期化された <a class="reference internal" href="#c.grn_ctx" title="grn_ctx"><code class="xref c c-type docutils literal notranslate"><span class="pre">grn_ctx</span></code></a> オブジェクトを返します。</p>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_ctx_close">
grn_rc <code class="sig-name descname">grn_ctx_close</code><span class="sig-paren">(</span><a class="reference internal" href="#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_ctx_close" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p><a class="reference internal" href="#c.grn_ctx_fin" title="grn_ctx_fin"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_ctx_fin()</span></code></a> を呼び出し、その後、 <a class="reference internal" href="#c.grn_ctx_open" title="grn_ctx_open"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_ctx_open()</span></code></a> によって割り当てた <code class="docutils literal notranslate"><span class="pre">ctx</span></code> のメモリを解放する。</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> -- もう使わない <a class="reference internal" href="#c.grn_ctx" title="grn_ctx"><code class="xref c c-type docutils literal notranslate"><span class="pre">grn_ctx</span></code></a> 。</p></li>
</ul>
</dd>
<dt class="field-even">戻り値</dt>
<dd class="field-even"><p>成功時は <code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> 、エラー時は <code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> 以外。</p>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_ctx_set_finalizer">
grn_rc <code class="sig-name descname">grn_ctx_set_finalizer</code><span class="sig-paren">(</span><a class="reference internal" href="#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_proc.html#c.grn_proc_func" title="grn_proc_func">grn_proc_func</a> *<em>func</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_ctx_set_finalizer" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>ctxを破棄するときに呼ばれる関数を設定します。</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> -- 対象ctxを指定します。</p></li>
<li><p><strong>func</strong> -- <code class="docutils literal notranslate"><span class="pre">ctx</span></code> を破棄するときに呼ばれる関数を指定します。</p></li>
</ul>
</dd>
<dt class="field-even">戻り値</dt>
<dd class="field-even"><p>成功時は <code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> 、エラー時は <code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> 以外。</p>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_ctx_get_command_version">
<a class="reference internal" href="grn_command_version.html#c.grn_command_version" title="grn_command_version">grn_command_version</a> <code class="sig-name descname">grn_ctx_get_command_version</code><span class="sig-paren">(</span><a class="reference internal" href="#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_ctx_get_command_version" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>command_versionを返します。</p>
</dd></dl>

<dl class="c function">
<dt id="c.grn_ctx_set_command_version">
grn_rc <code class="sig-name descname">grn_ctx_set_command_version</code><span class="sig-paren">(</span><a class="reference internal" href="#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_command_version.html#c.grn_command_version" title="grn_command_version">grn_command_version</a> <em>version</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_ctx_set_command_version" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>command_versionを変更します。</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>version</strong> -- 変更後のcommand_versionを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_ctx_use">
grn_rc <code class="sig-name descname">grn_ctx_use</code><span class="sig-paren">(</span><a class="reference internal" href="#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>db</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_ctx_use" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>ctxが操作対象とするdbを指定します。NULLを指定した場合は、dbを操作しない状態(init直後の状態)になります。</p>
<p><code class="docutils literal notranslate"><span class="pre">GRN_CTX_PER_DB</span></code> フラグを指定した <a class="reference internal" href="#c.grn_ctx" title="grn_ctx"><code class="xref c c-type docutils literal notranslate"><span class="pre">grn_ctx</span></code></a> と一緒に使ってはいけません。</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>db</strong> -- ctxが使用するdbを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_ctx_db">
<a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<code class="sig-name descname">grn_ctx_db</code><span class="sig-paren">(</span><a class="reference internal" href="#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_ctx_db" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>ctxが現在操作対象としているdbを返します。dbを使用していない場合はNULLを返します。</p>
</dd></dl>

<dl class="c function">
<dt id="c.grn_ctx_get">
<a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<code class="sig-name descname">grn_ctx_get</code><span class="sig-paren">(</span><a class="reference internal" href="#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <em class="property">const</em> char *<em>name</em>, int <em>name_size</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_ctx_get" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>ctxが使用するdbからnameに対応するオブジェクトを検索して返す。nameに一致するオブジェクトが存在しなければNULLを返す。</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>name</strong> -- 検索しようとするオブジェクトの名前。</p></li>
<li><p><strong>name_size</strong> -- 名前のバイト数。負の値が指定された場合は、終端をNULL文字とした文字列として扱われる。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_ctx_at">
<a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<code class="sig-name descname">grn_ctx_at</code><span class="sig-paren">(</span><a class="reference internal" href="#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, grn_id <em>id</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_ctx_at" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>ctx、またはctxが使用するdbからidに対応するオブジェクトを検索して返す。idに一致するオブジェクトが存在しなければNULLを返す。</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>id</strong> -- 検索しようとするオブジェクトのidを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_ctx_get_all_tables">
grn_rc <code class="sig-name descname">grn_ctx_get_all_tables</code><span class="sig-paren">(</span><a class="reference internal" href="#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>tables_buffer</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_ctx_get_all_tables" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>It pushes all tables in the database of <code class="docutils literal notranslate"><span class="pre">ctx</span></code> into
<code class="docutils literal notranslate"><span class="pre">tables_buffer</span></code>. <code class="docutils literal notranslate"><span class="pre">tables_buffer</span></code> should be initialized as
<code class="docutils literal notranslate"><span class="pre">GRN_PVECTOR</span></code>. You can use <code class="docutils literal notranslate"><span class="pre">GRN_PTR_INIT()</span></code> with
<code class="docutils literal notranslate"><span class="pre">GRN_OBJ_VECTOR</span></code> flags to initialize <code class="docutils literal notranslate"><span class="pre">tables_buffer</span></code>.</p>
<p>以下は例です。</p>
<div class="highlight-c notranslate"><div class="highlight"><pre><span></span><span class="n">grn_rc</span> <span class="n">rc</span><span class="p">;</span>
<span class="n">grn_obj</span> <span class="n">tables</span><span class="p">;</span>
<span class="kt">int</span> <span class="n">i</span><span class="p">;</span>
<span class="kt">int</span> <span class="n">n_tables</span><span class="p">;</span>

<span class="n">GRN_PTR_INIT</span><span class="p">(</span><span class="o">&amp;</span><span class="n">tables</span><span class="p">,</span> <span class="n">GRN_OBJ_VECTOR</span><span class="p">,</span> <span class="n">GRN_ID_NIL</span><span class="p">);</span>
<span class="n">rc</span> <span class="o">=</span> <span class="n">grn_ctx_get_all_tables</span><span class="p">(</span><span class="n">ctx</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">tables</span><span class="p">);</span>
<span class="k">if</span> <span class="p">(</span><span class="n">rc</span> <span class="o">!=</span> <span class="n">GRN_SUCCESS</span><span class="p">)</span> <span class="p">{</span>
  <span class="n">GRN_OBJ_FIN</span><span class="p">(</span><span class="n">ctx</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">tables</span><span class="p">);</span>
  <span class="cm">/* Handle error. */</span>
  <span class="k">return</span><span class="p">;</span>
<span class="p">}</span>

<span class="n">n_tables</span> <span class="o">=</span> <span class="n">GRN_BULK_VSIZE</span><span class="p">(</span><span class="o">&amp;</span><span class="n">tables</span><span class="p">)</span> <span class="o">/</span> <span class="k">sizeof</span><span class="p">(</span><span class="n">grn_obj</span> <span class="o">*</span><span class="p">);</span>
<span class="k">for</span> <span class="p">(</span><span class="n">i</span> <span class="o">=</span> <span class="mi">0</span><span class="p">;</span> <span class="n">i</span> <span class="o">&lt;</span> <span class="n">n_tables</span><span class="p">;</span> <span class="n">i</span><span class="o">++</span><span class="p">)</span> <span class="p">{</span>
  <span class="n">grn_obj</span> <span class="o">*</span><span class="n">table</span> <span class="o">=</span> <span class="n">GRN_PTR_VALUE_AT</span><span class="p">(</span><span class="o">&amp;</span><span class="n">tables</span><span class="p">,</span> <span class="n">i</span><span class="p">);</span>
  <span class="cm">/* Use table. */</span>
<span class="p">}</span>

<span class="cm">/* Free resources. */</span>
<span class="k">for</span> <span class="p">(</span><span class="n">i</span> <span class="o">=</span> <span class="mi">0</span><span class="p">;</span> <span class="n">i</span> <span class="o">&lt;</span> <span class="n">n_tables</span><span class="p">;</span> <span class="n">i</span><span class="o">++</span><span class="p">)</span> <span class="p">{</span>
  <span class="n">grn_obj</span> <span class="o">*</span><span class="n">table</span> <span class="o">=</span> <span class="n">GRN_PTR_VALUE_AT</span><span class="p">(</span><span class="o">&amp;</span><span class="n">tables</span><span class="p">,</span> <span class="n">i</span><span class="p">);</span>
  <span class="n">grn_obj_unlink</span><span class="p">(</span><span class="n">ctx</span><span class="p">,</span> <span class="n">table</span><span class="p">);</span>
<span class="p">}</span>
<span class="n">GRN_OBJ_FIN</span><span class="p">(</span><span class="n">ctx</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">tables</span><span class="p">);</span>
</pre></div>
</div>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> -- その時点のコンテキスト。</p></li>
<li><p><strong>table_buffer</strong> -- The output buffer to store tables.</p></li>
</ul>
</dd>
<dt class="field-even">戻り値</dt>
<dd class="field-even"><p>成功時は <code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> 、エラー時は <code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> 以外。</p>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_ctx_get_output_type">
<a class="reference internal" href="grn_content_type.html#c.grn_content_type" title="grn_content_type">grn_content_type</a> <code class="sig-name descname">grn_ctx_get_output_type</code><span class="sig-paren">(</span><a class="reference internal" href="#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_ctx_get_output_type" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>コンテキストの出力形式を取得します。</p>
<p>Normally, this function isn't needed.</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> -- その時点のコンテキスト。</p></li>
</ul>
</dd>
<dt class="field-even">戻り値</dt>
<dd class="field-even"><p>The output type of the context.</p>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_ctx_set_output_type">
grn_rc <code class="sig-name descname">grn_ctx_set_output_type</code><span class="sig-paren">(</span><a class="reference internal" href="#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_content_type.html#c.grn_content_type" title="grn_content_type">grn_content_type</a> <em>type</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_ctx_set_output_type" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>Sets the new output type to the context. It is used by executing a
command by <a class="reference internal" href="grn_expr.html#c.grn_expr_exec" title="grn_expr_exec"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_expr_exec()</span></code></a>. If you use
<code class="xref c c-func docutils literal notranslate"><span class="pre">grn_ctx_send()</span></code>, the new output type isn't
used. <code class="xref c c-func docutils literal notranslate"><span class="pre">grn_ctx_send()</span></code> sets output type from command line
internally.</p>
<p>Normally, this function isn't needed.</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> -- その時点のコンテキスト。</p></li>
<li><p><strong>type</strong> -- 新しい出力形式。</p></li>
</ul>
</dd>
<dt class="field-even">戻り値</dt>
<dd class="field-even"><p>成功時は <code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> 、エラー時は <code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> 以外。</p>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_ctx_is_opened">
grn_bool_rc <code class="sig-name descname">grn_ctx_is_opened</code><span class="sig-paren">(</span><a class="reference internal" href="#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, grn_id <em>id</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_ctx_is_opened" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>指定したIDのオブジェクトが開かれているかどうかをチェックします。</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> -- その時点のコンテキスト。</p></li>
<li><p><strong>id</strong> -- チェック対象のオブジェクトのID。</p></li>
</ul>
</dd>
<dt class="field-even">戻り値</dt>
<dd class="field-even"><p>指定したIDのオブジェクトが開かれていたら <code class="docutils literal notranslate"><span class="pre">GRN_TRUE</span></code> 、そうでなければ <code class="docutils literal notranslate"><span class="pre">GRN_FALSE</span></code> 。</p>
</dd>
</dl>
</dd></dl>

</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">目次</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.25.8. <code class="docutils literal notranslate"><span class="pre">grn_ctx</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.25.8.1. 概要</a></li>
<li><a class="reference internal" href="#example">7.25.8.2. 例</a></li>
<li><a class="reference internal" href="#reference">7.25.8.3. リファレンス</a></li>
</ul>
</li>
</ul>

  <h4>前のトピックへ</h4>
  <p class="topless"><a href="grn_content_type.html"
                        title="前の章へ"><span class="section-number">7.25.7. </span><code class="docutils literal notranslate"><span class="pre">grn_content_type</span></code></a></p>
  <h4>次のトピックへ</h4>
  <p class="topless"><a href="grn_db.html"
                        title="次の章へ"><span class="section-number">7.25.9. </span><code class="docutils literal notranslate"><span class="pre">grn_db</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">クイック検索</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="検索" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             >索引</a></li>
        <li class="right" >
          <a href="grn_db.html" title="7.25.9. grn_db"
             >次へ</a> |</li>
        <li class="right" >
          <a href="grn_content_type.html" title="7.25.7. grn_content_type"
             >前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../api.html" ><span class="section-number">7.25. </span>API</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.25.8. </span><code class="docutils literal notranslate"><span class="pre">grn_ctx</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>